package launcher;

import javafx.application.Application;
import javafx.stage.Stage;
import model.*;
import view.CapteurView;
import view.ImageCtrlView;
import view.ThermostatView;

import java.io.IOException;
import java.util.Map;

public class Launch extends Application {
    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) throws IOException, InterruptedException {

        UnitCapteur captorI = new UnitCapteur(2,"Capteur Intervalle",new StrategyCPU());
        UnitCapteur captorR = new UnitCapteur(3,"Capteur Realiste", new StrategyCPU());
        UnitCapteur captorC = new UnitCapteur(4,"Capteur CPU",new StrategyCPU());
        CapteurVirtuel captorV = new CapteurVirtuel(5,"CapteurVirtuel");

        captorV.addCapteur(captorI,1);
        captorV.addCapteur(captorC,1);
        captorV.addCapteur(captorR,1);

        // FXML NOT WORKING
        Stage thermostatStage = new Stage();
        CapteurView capteurView = new ImageCtrlView(captorV,"view/Image.fxml","mon titre");
        for (Map.Entry<CapteurAbstrait, Integer> entry : captorV.getCapteurs().entrySet()) {
            CapteurAbstrait c = entry.getKey();
            c.genTemp();
        }
        ThermostatView thermostatView = new ThermostatView(captorV,"view/Thermostat.fxml","mon titre");

        //Random random = new Random();

        Thread t = new Thread() {
            public void run() {
                while (true) {
                    captorV.genTemp();
                    try {
                        System.out.println(captorV.getNom() + ": " + captorV.getTemp().getValue() + " °C");
                        for (Map.Entry<CapteurAbstrait, Integer> entry : captorV.getCapteurs().entrySet()) {
                            CapteurAbstrait c = entry.getKey();
                            c.genTemp();
                            System.out.println(c.getNom() + ": " + c.getTemp().getValue() + " °C");
                            System.out.println(c.getNom() + ": " + c.getTemp().getValue() + " °C");
                        }

                        sleep(4000);
                    } catch (InterruptedException e) {
                        throw new RuntimeException(e);
                    }
                }
            }
        };
        t.start();
    }
}

